@ECHO OFF
SETLOCAL ENABLEDELAYEDEXPANSION
set MODPATH=%~dp0
set SCRIPT_NAME=%~n0
set LOGFILE_TIME=%DATE%_%TIME::=.%
set LOGFILE_TIME=%LOGFILE_TIME:,=.%
set LOGFILE_TIME=%LOGFILE_TIME: =%
set LOGFILE=%MODPATH%\supportdata\log\%SCRIPT_NAME%_%LOGFILE_TIME%.log
goto CREATE_LOGFILE


:CREATE_LOGFILE
echo. >%LOGFILE%
goto SHOW_CREDITS


:SHOW_CREDITS
call :WRITE_LOG ""
call :WRITE_LOG "C R E D I T S"
call :WRITE_LOG "-------------------------------------"
call :WRITE_LOG ""
call :WRITE_LOG "Author: Gerion"
call :WRITE_LOG ""
call :WRITE_LOG "Das Paket enthaelt und verwendet folgende Drittanbieter-Software:"
call :WRITE_LOG "- nltpack (mit freundlicher Genehmigung des Autors [Hendrik Radke]): https://github.com/Henne/BrightEyes/tree/master/tools/nltpack"
call :WRITE_LOG "- SoX (GPL): http://sox.sourceforge.net/"
call :WRITE_LOG "- MinGW (GPL): http://www.mingw.org/"
call :WRITE_LOG ""
call :WRITE_LOG "-------------------------------------"
call :WRITE_LOG ""
call :WRITE_LOG "DIESES SKRIPT STELLT DURCH DEN MOD 'SCHICKHD2DOSSOUND' VERAENDERTE SCHICKSALSKLINGE RE/HD ORIGINAL-DATEIEN WIEDER HER"
call :WRITE_LOG ""
call :WRITE_LOG "!DIESES SKRIPT MUSS LEIDER MIT ADMINISTRATOR-RECHTEN AUSGEFUEHRT WERDEN!"
call :WRITE_LOG ""
pause


:CHECK_ADMIN_RIGHTS
call :WRITE_LOG "Verifiziere Administrator-Rechte..."
net session >NUL 2>&1
if errorlevel 1 (
	echo.
	call :WRITE_LOG "WARNUNG: Administrator-Rechte konnten nicht bestaetigt werden."
	echo.
	call :WRITE_LOG "WARNUNG: FAHREN SIE NUR FORT WENN SIE SICH SICHER SIND,"
	call :WRITE_LOG "WARNUNG: DASS DAS SCRIPT -ALS ADMINISTRATOR- AUSGEFUEHRT WIRD!"
	echo.
	call :ASK_FOR_CONTINUE
) else (
	call :WRITE_LOG "Administrator-Rechte wurden festgestellt."
)
goto FIND_SCHICK_HD_UNINSTALLER_PATH_HD


:FIND_SCHICK_HD_UNINSTALLER_PATH_HD
call :WRITE_LOG "Suche Uninstaller Pfad..."
for /F "tokens=* USEBACKQ" %%F in (`reg query HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall /d /f "Das Schwarze Auge - Schicksalsklinge" /s ^& reg query HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall /d /f "Realms of Arkania: Blade of Destiny" /s`) do (
	echo "%%F"|findstr /i "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall" >NUL
	if "!ERRORLEVEL!" == "0" (
		set UNINSTALLER_PATH_HD=%%F
		call :WRITE_LOG "...Uninstaller Pfad identifiziert: !UNINSTALLER_PATH_HD!"
		goto FIND_SCHICK_HD_PATH
	)
)


:FIND_SCHICK_HD_PATH
call :WRITE_LOG "Suche Schicksalsklinge-HD-Pfad..."
for /f "tokens=1 delims=:" %%a in ('REG QUERY "%UNINSTALLER_PATH_HD%" /v InstallLocation ^|findstr /b /v HKEY_LOCAL_MACHINE') do (
	set SCHICKHDDRIVETMP=%%a
	set SCHICKHDDRIVE=!SCHICKHDDRIVETMP:~-1!:
)

for /f "tokens=2-9 delims=\" %%a in ('REG QUERY "%UNINSTALLER_PATH_HD%" /v InstallLocation ^|findstr /b /v HKEY_LOCAL_MACHINE') do (
	pushd "%SCHICKHDDRIVE%\%%a" >NUL 2>&1
	if exist ".\schick.exe" (
		set SCHICKHDPATH=%SCHICKHDDRIVE%\%%a
		call :WRITE_LOG "...Schick-HD-Pfad identifiziert: !SCHICKHDPATH!"
		popd >NUL 2>&1
		goto ASK_IF_SCHICKHDPATH_OK
	)	
	
	pushd "%SCHICKHDDRIVE%\%%a\%%b" >NUL 2>&1
	if exist ".\schick.exe" (
		set SCHICKHDPATH=%SCHICKHDDRIVE%\%%a\%%b
		call :WRITE_LOG "...Schick-HD-Pfad identifiziert: !SCHICKHDPATH!"
		popd >NUL 2>&1
		goto ASK_IF_SCHICKHDPATH_OK
	)	

	pushd "%SCHICKHDDRIVE%\%%a\%%b\%%c" >NUL 2>&1
	if exist ".\schick.exe" (
		set SCHICKHDPATH=%SCHICKHDDRIVE%\%%a\%%b\%%c
		call :WRITE_LOG "...Schick-HD-Pfad identifiziert: !SCHICKHDPATH!"
		popd >NUL 2>&1
		goto ASK_IF_SCHICKHDPATH_OK
	)	

	pushd "%SCHICKHDDRIVE%\%%a\%%b\%%c\%%d" >NUL 2>&1
	if exist ".\schick.exe" (
		set SCHICKHDPATH=%SCHICKHDDRIVE%\%%a\%%b\%%c\%%d
		call :WRITE_LOG "...Schick-HD-Pfad identifiziert: !SCHICKHDPATH!"
		popd >NUL 2>&1
		goto ASK_IF_SCHICKHDPATH_OK
	)	

	pushd "%SCHICKHDDRIVE%\%%a\%%b\%%c\%%d\%%e" >NUL 2>&1
	if exist ".\schick.exe" (
		set SCHICKHDPATH=%SCHICKHDDRIVE%\%%a\%%b\%%c\%%d\%%e
		call :WRITE_LOG "...Schick-HD-Pfad identifiziert: !SCHICKHDPATH!"
		popd >NUL 2>&1
		goto ASK_IF_SCHICKHDPATH_OK
	)	

	pushd "%SCHICKHDDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f" >NUL 2>&1
	if exist ".\schick.exe" (
		set SCHICKHDPATH=%SCHICKHDDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f
		call :WRITE_LOG "...Schick-HD-Pfad identifiziert: !SCHICKHDPATH!"
		popd >NUL 2>&1
		goto ASK_IF_SCHICKHDPATH_OK
	)	

	pushd "%SCHICKHDDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g" >NUL 2>&1
	if exist ".\schick.exe" (
		set SCHICKHDPATH=%SCHICKHDDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g
		call :WRITE_LOG "...Schick-HD-Pfad identifiziert: !SCHICKHDPATH!"
		popd >NUL 2>&1
		goto ASK_IF_SCHICKHDPATH_OK
	)	

	pushd "%SCHICKHDDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\%%h" >NUL 2>&1
	if exist ".\schick.exe" (
		set SCHICKHDPATH=%SCHICKHDDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\%%h
		call :WRITE_LOG "...Schick-HD-Pfad identifiziert: !SCHICKHDPATH!"
		popd >NUL 2>&1
		goto ASK_IF_SCHICKHDPATH_OK
	)	

	call :WRITE_LOG "...Schick-HD-Pfad konnte nicht identifiziert werden!"
	goto SCHICK_HD_PATH_NOT_FOUND
)


:SCHICK_HD_PATH_NOT_FOUND
call :WRITE_LOG "Pfad fuer Schicksalsklinge HD konnte nicht gefunden werden."
goto ASK_FOR_SCHICKHDPATH


:ASK_IF_SCHICKHDPATH_OK
call :WRITE_LOG ""
call :WRITE_LOG ""
call :WRITE_LOG "Ist Schicksalsklinge HD in folgendem Pfad installiert? (J/N)"
call :WRITE_LOG "%SCHICKHDPATH%"
set /P SCHICKHDPATH_CONFIRM=

if "%SCHICKHDPATH_CONFIRM%" == "j" (
	goto CHECK_SCHICKHDPATH
) else if "%SCHICKHDPATH_CONFIRM%" == "J" (
	goto CHECK_SCHICKHDPATH
) else if "%SCHICKHDPATH_CONFIRM%" == "n" (
	goto ASK_FOR_SCHICKHDPATH
) else if "%SCHICKHDPATH_CONFIRM%" == "N" (
	goto ASK_FOR_SCHICKHDPATH
) else (
	call :WRITE_LOG "FEHLERHAFTE EINGABE."
	call :WRITE_LOG "Bitte verwenden Sie J oder N"
	goto ASK_IF_SCHICKHDPATH_OK
)


:ASK_FOR_SCHICKHDPATH
call :WRITE_LOG ""
call :WRITE_LOG ""
call :WRITE_LOG "Bitte Pfad fuer Schicksalsklinge HD eingeben:"
call :WRITE_LOG "z.B.: C:\Program Files\Realms of Arkania"
set /P SCHICKHDPATH=
call :WRITE_LOG "Eingabe: %SCHICKHDPATH%"
goto CHECK_SCHICKHDPATH


:CHECK_SCHICKHDPATH
if not exist "%SCHICKHDPATH%" (
	call :WRITE_LOG "FEHLER: Verzeichnis konnte nicht gefunden werden."
	goto ASK_FOR_SCHICKHDPATH
)
goto RESTORE_ORG_FILES


:RESTORE_ORG_FILES
set RESTORE_ERROR_FLAG=
set FOUND_BACKUP_FILES_FLAG=
pushd "%SCHICKHDPATH%"
call :WRITE_LOG "Suche Backup-Dateien..."
for /r %%x in (*_org.schickhd2dossound.backup.*) do (
	set FOUND_BACKUP_FILES_FLAG=1
	set RESTORE_FILE=%%x
	call :WRITE_LOG "Verarbeite !RESTORE_FILE!..."
	
	echo !RESTORE_FILE!|findstr /I /R ogg$ >NUL
	if "!ERRORLEVEL!" == "0" (
		set ORG_FILE=!RESTORE_FILE:_org.schickhd2dossound.backup.ogg=!
		call :WRITE_LOG "Org-File: !ORG_FILE!"
		move /Y "!RESTORE_FILE!" "!ORG_FILE!" >>"%LOGFILE%" 2>&1
		if exist "!RESTORE_FILE!" (
			set RESTORE_ERROR_FLAG=1
			call :WRITE_LOG "FEHLER: Originaldatei konnte nicht wiederhergestellt werden."
			pause
		)
		
	) else (
		call :WRITE_LOG "FEHLER: Dateityp wird nicht unterstuetzt."
		pause
	)
)
popd
if "%FOUND_BACKUP_FILES_FLAG%" == "" (
	call :WRITE_LOG "...keine Backup-Dateien gefunden."
)
goto ENDE


:WRITE_LOG
set LOG_LINE_TO_WRITE="%1"
set LOG_LINE_TO_WRITE=%LOG_LINE_TO_WRITE:"=%

if "%LOG_LINE_TO_WRITE%" == "" (
	echo.
	goto :eof
)

echo %LOG_LINE_TO_WRITE%
echo "%DATE%_%TIME%: %LOG_LINE_TO_WRITE%" >>"%LOGFILE%"
goto :eof


:ASK_FOR_CONTINUE
set ASK_FOR_CONTINUE_ANSWER=
call :WRITE_LOG ""
call :WRITE_LOG ""
call :WRITE_LOG "Ein Fehler wurde festgestellt."
call :WRITE_LOG "Wollen Sie fortfahren?"
call :WRITE_LOG ""

set /P ASK_FOR_CONTINUE_ANSWER=
call :WRITE_LOG "Eingabe: %ASK_FOR_CONTINUE_ANSWER%"

if "%ASK_FOR_CONTINUE_ANSWER%" == "j" (
	goto :eof
) else if "%ASK_FOR_CONTINUE_ANSWER%" == "J" (
	goto goto :eof
) else if "%ASK_FOR_CONTINUE_ANSWER%" == "n" (
	goto ERROREXIT
) else if "%ASK_FOR_CONTINUE_ANSWER%" == "N" (
	goto ERROREXIT
) else (
	call :WRITE_LOG "FEHLERHAFTE EINGABE."
	call :WRITE_LOG "Bitte verwenden Sie J oder N"
	goto ASK_FOR_CONTINUE
)
goto goto :eof


:ERROREXIT
call :WRITE_LOG "FEHLER: Das Programm wird abgebrochen."
call :WRITE_LOG ""
call :WRITE_LOG "-----------------------------------------------------"
call :WRITE_LOG ""
call :WRITE_LOG "Protokolldatei: %LOGFILE%"
call :WRITE_LOG ""
call :WRITE_LOG "-----------------------------------------------------"
pause
exit 1


:ENDE
call :WRITE_LOG ""
call :WRITE_LOG "-----------------------------------------------------"
if "%RESTORE_ERROR_FLAG%" == "" (
	call :WRITE_LOG "SchickHD2DOSSound deaktiviert."
) else (
	call :WRITE_LOG "FEHLER bei der Deaktivierung von SchickHD2DOSSound."
)
call :WRITE_LOG ""
call :WRITE_LOG "Protokolldatei: %LOGFILE%"
call :WRITE_LOG ""
call :WRITE_LOG "-----------------------------------------------------"
call :WRITE_LOG ""
pause
